#include "ag101.h"

#define inw(reg)  (*((volatile unsigned int*) (reg)))
#define outw(reg, data) ((*((volatile unsigned int*) (reg)))=(unsigned int)(data))

#define UART_BASE       0x99600000
//#define UART_BASE       0x98200000

uart_init(void)
{
    /* baud 38400 8-n-1 */
    outw(UART_BASE + 0x0C, inw(UART_BASE + 0x0C)|0x80); // Set DLAB to 1
    outw(UART_BASE + 0x00, ((0x1e >> 0) & 0xff));   // DLL
    outw(UART_BASE + 0x04, ((0x1e >> 8) & 0xff));   // DLM
    outw(UART_BASE + 0x0C, 0x03); // LCR: Length 8, no parity, no stop bit.
    outw(UART_BASE + 0x08, 0x07); // FCR: Enable FIFO, reset TX and RX.
}

void bsp_outbyte(unsigned char c)
{
   while (inw(UART_BASE+0x08) & 0x10); // tx fifo full
   outw(UART_BASE+0x00,c); 
}
